package com.hfkj.dao;

import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

/**
 * mapper扩展类
 */
public interface BsTradeOrderMapperExt {

    @Select("<script>" +
            " select " +
            " case WHEN sum(trade_actual_amount) is not null then sum(trade_actual_amount) else 0 end tradePrice," +
            " count(1) count" +
            " from bs_trade_order " +
            " where 1 = 1" +
            " <if test='param.agentId != null'> and agent_id = #{param.agentId}</if>" +
            " <if test='param.salesmanId != null'> and salesman_id = #{param.salesmanId} </if>" +
            " <if test='param.merId != null'> and mer_id = #{param.merId} </if>" +
            " <if test='param.storeId != null'> and store_id = #{param.storeId} </if>" +
            " <if test='param.storeName != null'> and store_name CONCAT('%', #{param.storeName} , '%') </if>" +
            " <if test='param.payMode != null'> and pay_mode = #{param.payMode}</if>" +
            " <if test='param.outTradeNo != null'> and out_trade_no like CONCAT('%', #{param.outTradeNo} , '%')</if>" +
            " <if test='param.accTradeNo != null'> and acc_trade_no = #{param.accTradeNo}</if>" +
            " <if test='param.payTimeS != null'> <![CDATA[  and pay_time >= #{param.payTimeS} ]]>  </if>" +
            " <if test='param.payTimeE != null'> <![CDATA[  and pay_time <= #{param.payTimeE} ]]>  </if>" +
            " <if test='param.status != null'> and status = #{param.status}</if>" +
            "</script>")
    Map<String,Object> countTradeOrderPrice(@Param("param") Map<String, Object> param);


    @Select("<script>" +
            "  select  " +
            " a.days settleDay," +
            " #{param.merNo} merNo, " +
            " case when b.tradeNum is null then 0 else b.tradeNum end tradeNum,  " +
            " case when b.tradeAmount is null then 0 else b.tradeAmount end tradeAmount,  " +
            " case when b.settleAmount is null then 0 else b.settleAmount end settleAmount,  " +
            " case when b.shdFeeAmount is null then 0 else b.shdFeeAmount end shdFeeAmount " +
            " from ( " +
            " SELECT date_add(date_sub(#{param.settleTimeS},interval 1 day), INTERVAL ( cast( help_topic_id AS signed INTEGER ) + 1 ) day) days  " +
            " FROM mysql.help_topic  " +
            " WHERE help_topic_id <![CDATA[ < ]]> DATEDIFF(#{param.settleTimeE},date_sub(#{param.settleTimeS},interval 1 day)) ORDER BY help_topic_id) a " +
            " LEFT JOIN (" +
            " select " +
            " a.settle_date settle_date," +
            " (a.tradeNum + b.tradeNum) tradeNum," +
            " (a.tradeAmount - b.tradeAmount) tradeAmount, " +
            " (a.settleAmount - b.settleAmount) settleAmount, " +
            " (a.shdFeeAmount - b.shdFeeAmount) shdFeeAmount " +
            " from (select " +
            " settle_date, " +
            " count(1) tradeNum, " +
            " sum(trade_amount) tradeAmount, " +
            " sum(settle_amount) settleAmount, " +
            " sum(shd_fee_amt) shdFeeAmount " +
            " from bs_trade_settle " +
            " where settle_date between #{param.settleTimeS} and #{param.settleTimeE}  " +
            " and mer_no = #{param.merNo} " +
            " and trade_type = 1" +
            " and `status` = 1" +
            " GROUP BY settle_date) a," +
            " (select " +
            " settle_date, " +
            " count(1) tradeNum, " +
            " sum(trade_amount) tradeAmount, " +
            " sum(settle_amount) settleAmount, " +
            " sum(shd_fee_amt) shdFeeAmount " +
            " from bs_trade_settle " +
            " where settle_date between #{param.settleTimeS} and #{param.settleTimeE}  " +
            " and mer_no = #{param.merNo} " +
            " and trade_type = 2" +
            " and `status` = 1" +
            " GROUP BY settle_date) b where a.settle_date = b.settle_date GROUP BY a.settle_date" +
            " ) b on b.settle_date = a.days  " +
            " ORDER BY a.days desc;" +
            " </script>")
    List<Map<String,Object>> queryTradeOrderDetailCount(@Param("param") Map<String, Object> param);

}
